// Committee.java
package com.jdojo.chapter1;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class Committee {
	private CommitteeMember[] member;

	// Define an inner class that implements the Iterator interface
	private class InnerItr implements Iterator {
		private int pointer = 0;

		InnerItr() {
		}

		public boolean hasNext() {
			return (pointer != Committee.this.member.length);
		}

		public Object next() {
			if (pointer == member.length) {
				throw new NoSuchElementException();
			}

			return member[pointer++];
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	} // end of the inner class

	public Committee(int count) {
		this.member = new CommitteeMember[count];
	}

	public void set(int index, CommitteeMember member) {
		this.member[index] = member;
	}

	public Iterator iterator() {
		// Return a new Iterator object of InnerItr type
		return new InnerItr();
	}
}
