// ComparablePerson.java
package com.jdojo.chapter1;

public class ComparablePerson implements Comparable {
	private String first;
	private String last;

	public ComparablePerson(String first, String last) {
		this.first = first;
		this.last = last;
	}

	public String getFirst(){
		return first;
	}

	public String getLast(){
		return last;
	}

	// Compares two persons based on their last names.
	// If last names are the same, use first names
	public int compareTo(Object obj) {
		// If obj is not an instance of Comparable Person, 
		// the following cast will throw exception	
		ComparablePerson anotherPerson = (ComparablePerson) obj;
		String anotherPersonLastName = anotherPerson.last;
		String anotherPersonFirstName = anotherPerson.first;

		int diff = this.last.compareTo(anotherPerson.last);
		if (diff == 0) {
		  diff = this.first.compareTo(anotherPerson.first);
		}
		return diff;
	}

	public String toString() {
		return last + ", " + first;
	}
}
