// FileChannelRead.java
package com.jdojo.chapter10;

import java.nio.channels.FileChannel;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import java.io.IOException;

public class FileChannelRead {
	public static void main(String[] args) {
		String fileName = "luci1.txt";
		FileInputStream fis = null;
		FileChannel fileChannel = null;
		ByteBuffer buffer = null;

		try {
			// Obtain channel for luci1.txt file to read from it
			fis = new FileInputStream(fileName);
			fileChannel = fis.getChannel();

			// Create a buffer
			buffer = ByteBuffer.allocate(1024);

			// Read all data from the channel
			while (fileChannel.read(buffer) > 0) {
				// Flip the buffer before we can read data from it
				buffer.flip();

				/* Display the read data as characters on the console
				   Note that we are assuming that a byte represents a
				   character, which is not true all the time. In a 
				   real world application, you should use 						   CharsetDecoder to decode the bytes into character 
				   before you 	display/use them.
				*/
				while (buffer.hasRemaining()) {
					byte b = buffer.get();

					// Assuming a byte represents a character
					System.out.print((char) b); 
				}

				// Clear the buffer before next read into it
				buffer.clear();
			}

			// File channel is closed in the finally block
		}
		catch (IOException e1) {
			e1.printStackTrace();
		}
		finally {
			if (fileChannel != null) {
				try {
					fileChannel.close();
				} 
				catch (IOException e2) {
					e2.printStackTrace();
				}
			}
		}
	}
}
