// FileChannelWrite.java
package com.jdojo.chapter10;

import java.nio.channels.FileChannel;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.io.FileOutputStream;

public class FileChannelWrite {
	public static void main(String[] args) {
		String fileName = "luci5.txt";
		FileOutputStream fos = null;
		FileChannel fileChannel = null;
		ByteBuffer buffer = null;

		try {
			// Obtain channel for luci1.txt file to read from it
			fos = new FileOutputStream(fileName);
			fileChannel = fos.getChannel();

			// Get the text as string 
			String text = getText();

			// Convert text into byte array
			byte[] byteData = text.toString().getBytes("UTF-8");

			// Create a ByteBuffer using the byte array
			buffer = ByteBuffer.wrap(byteData);

			// Write bytes to the file
			fileChannel.write(buffer);

			System.out.println("Data has been written to " + fileName);

			// File channel is closed in the finally block
		}
		catch (IOException e1) {
			e1.printStackTrace();
		}
		finally {
			if (fileChannel != null) {
				try {
					fileChannel.close();
				}
				catch (IOException e2) {
					e2.printStackTrace();
				}
			}
		}
	}

	public static String getText() {
		String lineSeparator = System.getProperty("line.separator");
		StringBuilder sb = new StringBuilder();
		sb.append("In one of those sweet dreams I slept,");
		sb.append(lineSeparator);
		sb.append("Kind Nature’s gentlest boon!");
		sb.append(lineSeparator);
		sb.append("And all the while my eyes I kept");
		sb.append(lineSeparator);
		sb.append("On the descending moon.");

		return sb.toString();
	}
}
