// FileOwnerManagement.java
package com.jdojo.chapter11;

import java.io.IOException;
import java.nio.file.FileSystem;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.FileOwnerAttributeView;
import java.nio.file.attribute.UserPrincipal;
import java.nio.file.attribute.UserPrincipalLookupService;

public class FileOwnerManagement {
	public static void main(String[] args) throws IOException {		
		try {
			Path path = Paths.get("C:\\poems\\luci1.txt");
			
			FileOwnerAttributeView foav =
			 Files.getFileAttributeView(
				          path,FileOwnerAttributeView.class);

			UserPrincipal owner = foav.getOwner();
			System.out.format("Original owner of %s is %s%n",
			                  path, owner.getName());
			
			FileSystem fs = FileSystems.getDefault();
			UserPrincipalLookupService upls = 			
			                   fs.getUserPrincipalLookupService();
			
			// Change the file owner to brice
			UserPrincipal newOwner = null;
			newOwner = upls.lookupPrincipalByName("brice");
			foav.setOwner(newOwner);

			UserPrincipal changedOwner = foav.getOwner();
			System.out.format("New owner of %s is %s%n",
			                  path, changedOwner.getName());
		} 
		catch (UnsupportedOperationException e) {
			e.printStackTrace();
		} 
		catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
