// BlockingQueueConsumer.java
package com.jdojo.chapter12;

import java.util.concurrent.BlockingQueue;
import java.util.Random;

public class BlockingQueueConsumer implements Runnable {
	private BlockingQueue queue;
	private String consumerName;
	private Random random = new Random();

	public BlockingQueueConsumer(BlockingQueue queue,
	                             String consumerName) {
		this.queue = queue;
		this.consumerName = consumerName;
	}

	public void run() {
		String str = null;
		while (true) {
			try {
				System.out.println(consumerName + 
				                   " is trying to take an element. " + 
				                   "Remaining capacity: " + 
				                   queue.remainingCapacity());

				str = (String) this.queue.take();

				System.out.println(consumerName + " took: " + str);

				// Sleep between 1 and 5 seconds
				int sleepTime = (random.nextInt(5) + 1) * 1000;
				Thread.sleep(sleepTime);
			}
			catch (InterruptedException e) {
				e.printStackTrace();
				break;
			}
		}
	}
}
