// BlockingQueueProducer.java
package com.jdojo.chapter12;

import java.util.concurrent.BlockingQueue;
import java.util.Random;

public class BlockingQueueProducer implements Runnable {
	private BlockingQueue queue;
	private String producerName;
	private int nextNumber = 1;
	private Random random = new Random();

	public BlockingQueueProducer(BlockingQueue queue,
			String producerName) {
		this.queue = queue;
		this.producerName = producerName;
	}

	public void run() {
		String str = null;
		while (true) {
			try {
				str = producerName + "-" + nextNumber;
				System.out.println(producerName + 
				                   " is trying to add: " + str + 
				                   ". Remaining capacity: " + 
				                   queue.remainingCapacity());
				this.queue.put(str);
				nextNumber++;
				System.out.println(producerName + " added: " + str);

				// Sleep between 1 and 5 seconds
				int sleepTime = (random.nextInt(5) + 1) * 1000;
				Thread.sleep(sleepTime);
			}
			catch (InterruptedException e) {
				e.printStackTrace();
				break;
			}
		}
	}
}
