// DelayQueueTest.java
package com.jdojo.chapter12;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.DelayQueue;

public class DelayQueueTest {
	public static void main(String[] args) throws InterruptedException {
		long currentTime = System.currentTimeMillis();

		/* Create three delayed job and add them to the queue
		   Jobs should run in sequence as
		   1. Populate Data (After 3000 milliseconds)
		   2. Balance Data (After 6000 milliseconds)
		   3. Print Data (After 9000 milliseconds)
		 */
		BlockingQueue queue = new DelayQueue();
		queue.put(new DelayedJob("Print Data", currentTime + 9000));
		queue.put(new DelayedJob("Populate Data", currentTime + 3000));
		queue.put(new DelayedJob("Balance Data", currentTime + 6000));

		while (queue.size() > 0) {
			System.out.println("Waiting to take a job from queue...");
			DelayedJob job = (DelayedJob) queue.take();
			System.out.println("Took Job: " + job);
		}

		System.out.println("Finished running all jobs.");
	}
}
