// DequeAsQueue.java
package com.jdojo.chapter12;

import java.util.Deque;
import java.util.LinkedList;

public class DequeAsQueue {
	public static void main(String[] args) {
		// Create a Deque and add elements at its tail
		// using addLast() or offerLast() method
		Deque deque = new LinkedList();
		deque.addLast("John");
		deque.offerLast("Richard");
		deque.offerLast("Donna");
		deque.offerLast("Ken");

		System.out.println("Deque: " + deque);

		// Let us keep removing elements from the Deque until
		// there is no element left
		while (deque.peekFirst() != null) {
			System.out.println("Head Element: " + deque.peekFirst());
			deque.removeFirst();
			System.out.println("Removed one element from Deque");
			System.out.println("Deque: " + deque);
		}

		// Now the Deque is empty. Try to call its peekFirst(),
		// getFirst(), pollFirst() and removeFirst() methods
		System.out.println("deque.isEmpty(): " + deque.isEmpty());

		System.out.println("deque.peekFirst(): " + deque.peekFirst());
		System.out.println("deque.pollFirst(): " + deque.pollFirst());

		try {
			String str = (String) deque.getFirst();
			System.out.println("deque.getFirst(): " + str);
		}
		catch (Exception e) {
			System.out.println("deque.getFirst() threw exception");
		}

		try {
			String str = (String) deque.removeFirst();
			System.out.println("deque.removeFirst(): " + str);
		}
		catch (Exception e) {
			System.out.println("deque.removeFirst() threw exception");
		}
	}
}
