// NavigableMapTest.java
package com.jdojo.chapter12;

import java.util.TreeMap;
import java.util.NavigableMap;
import java.util.Map.Entry;

public class NavigableMapTest {
	public static void main(String[] args) {
		NavigableMap nMap = new TreeMap();
		nMap.put("John", "(342)113-9878");
		nMap.put("Richard", "(245)890-9045");
		nMap.put("Donna", "(205)678-9823");
		nMap.put("Ken", "(205)678-9823");

		System.out.println("Navigable Map:" + nMap);

		// Get the closest lower and higher matches for Ken
		Entry lowerKen = nMap.lowerEntry("Ken");
		Entry floorKen = nMap.floorEntry("Ken");
		Entry higherKen = nMap.higherEntry("Ken");
		Entry ceilingKen = nMap.ceilingEntry("Ken");

		System.out.println("Lower Ken: " + lowerKen);
		System.out.println("Floor Ken: " + floorKen);
		System.out.println("Higher Ken: " + higherKen);
		System.out.println("Ceiling Ken: " + ceilingKen);

		// Get the reverse order view of the map
		NavigableMap reverseMap = nMap.descendingMap();
		System.out.println("Navigable Map(Reverse Order):" + 
		                   reverseMap);
	}
}
