// NavigableSetTest.java
package com.jdojo.chapter12;

import java.util.TreeSet;
import java.util.NavigableSet;

public class NavigableSetTest {
	public static void main(String[] args) {
		// Create a navigable set and add five integers
		NavigableSet ns = new TreeSet();
		ns.add(1); // use ns.add(new Integer(1)) for Java 4 or lower
		ns.add(2); // use ns.add(new Integer(2)) for Java 4 or lower
		ns.add(3); // use ns.add(new Integer(3)) for Java 4 or lower
		ns.add(4); // use ns.add(new Integer(4)) for Java 4 or lower
		ns.add(5); // use ns.add(new Integer(5)) for Java 4 or lower

		/* You will need to replace a number X used in a method 
		   call for ns with a new Integer(X) in the code below if 
		   you are using a version of Java lower than Java 5.
		   Otherwise, the code will not compile.
		 */

		System.out.println("Navigable Set: " + ns);

		System.out.println("\nReverse view of the set");

		NavigableSet reverseNs = ns.descendingSet();
		System.out.println("Reverse Order Navigable Set: " + 
						reverseNs);

		System.out.println("\nGetting subset of the set");
		NavigableSet threeOrMore = ns.tailSet(3, true);
		System.out.println("3 or more: " + threeOrMore);

		System.out.println("\nSearching through the set");

		System.out.println("lower(3): " + ns.lower(3));
		System.out.println("floor(3): " + ns.floor(3));
		System.out.println("higher(3): " + ns.higher(3));
		System.out.println("ceiling(3): " + ns.ceiling(3));

		System.out.println("\nPolling elements from the set");

		// Poll elements one by one and look at the set
		System.out.println("pollFirst(): " + ns.pollFirst());
		System.out.println("Navigable Set: " + ns);

		System.out.println("pollLast(): " + ns.pollLast());
		System.out.println("Navigable Set: " + ns);

		System.out.println("pollFirst(): " + ns.pollFirst());
		System.out.println("Navigable Set: " + ns);

		System.out.println("pollFirst(): " + ns.pollFirst());
		System.out.println("Navigable Set: " + ns);

		System.out.println("pollFirst(): " + ns.pollFirst());
		System.out.println("Navigable Set: " + ns);

		// Since the set is empty, polling will return null
		System.out.println("pollFirst(): " + ns.pollFirst());
		System.out.println("pollLast(): " + ns.pollLast());
	}
}
