// Person.java
package com.jdojo.chapter12;

public class Person {
	private int id;
	private String name;

	public Person(int id, String name) {
		this.setId(id);
		this.setName(name);
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	// Id and name must be the same for two Persons to be equal
	public boolean equals(Object o) {
		if (!(o instanceof Person)) {
			return false;
		}

		Person p = (Person) o;
		if (this.id == p.getId() && this.name.equals(p.getName())) {
			return true;
		}

		return false;
	}

	public int hashCode() {
		// Multiply id and hash code of name to minimize the conflict 
		// of having the same hash code for two different id and name
		int code = this.id * this.name.hashCode();
		return code;
	}

	public String toString() {
		return "(" + id + ", " + name + ")";
	}
}
