// PriorityQueueComparatorTest.java
package com.jdojo.chapter12;

import java.util.Queue;
import java.util.PriorityQueue;
import java.util.Comparator;

public class PriorityQueueComparatorTest {
	public static void main(String[] args) {
		Comparator nameComparator = new Comparator() {
			public int compare(Object o1, Object o2) {
				ComparablePerson cp1 = (ComparablePerson) o1;
				ComparablePerson cp2 = (ComparablePerson) o2;
				String cName1 = cp1.getName();
				String cName2 = cp2.getName();
				// Just use string comparison defined in String class
				return cName1.compareTo(cName2);
			}
		};

		int initialCapacity = 5;
		Queue pq = new PriorityQueue(initialCapacity,
				nameComparator);
		pq.add(new ComparablePerson(1, "John"));
		pq.add(new ComparablePerson(4, "Ken"));
		pq.add(new ComparablePerson(2, "Richard"));
		pq.add(new ComparablePerson(3, "Donna"));
		pq.add(new ComparablePerson(4, "Adam"));
		System.out.println("Priority queue: " + pq);

		while (pq.peek() != null) {
			System.out.println("Head Element: " + pq.peek());
			pq.remove();
			System.out.println("Removed one element from Queue");
			System.out.println("Priority queue: " + pq);
		}
	}
}
