// QueueTest.java
package com.jdojo.chapter12;

import java.util.LinkedList;
import java.util.Queue;

public class QueueTest {
	public static void main(String[] args) {
		Queue queue = new LinkedList();
		queue.add("John");
		// offer() will work the same as add()
		queue.offer("Richard"); 
		queue.offer("Donna");
		queue.offer("Ken");

		System.out.println("Queue: " + queue);

		// Let us keep removing elements from the Queue until
		// there is no element left
		while (queue.peek() != null) {
			System.out.println("Head Element: " + queue.peek());
			queue.remove();
			System.out.println("Removed one element from Queue");
			System.out.println("Queue: " + queue);
		}

		// Now Queue is empty. Try to call its peek(),
		// element(), poll() and remove() methods
		System.out.println("queue.isEmpty(): " + queue.isEmpty());

		System.out.println("queue.peek(): " + queue.peek());
		System.out.println("queue.poll(): " + queue.poll());

		try {
			String str = (String) queue.element();
			System.out.println("queue.element(): " + str);
		}
		catch (Exception e) {
			System.out.println("queue.element() threw exception");
		}

		try {
			String str = (String) queue.remove();
			System.out.println("queue.remove(): " + str);
		}
		catch (Exception e) {
			System.out.println("queue.remove() threw exception");
		}
	}
}
