// SetOperations.java
package com.jdojo.chapter12;

import java.util.HashSet;
import java.util.Set;

public class SetOperations {
	public static void main(String[] args) {
		// Create a set
		Set s1 = new HashSet();
		s1.add("John");
		s1.add("Donna");
		s1.add("Ken");

		// Create another set
		Set s2 = new HashSet();
		s2.add("Ellen");
		s2.add("Sara");
		s2.add("Donna");

		System.out.println("s1: " + s1);
		System.out.println("s2: " + s2);

		// Perform set operations
		performUnion(s1, s2);
		performIntersection(s1, s2);
		performDifference(s1, s2);
		testForSubset(s1, s2);
	}

	public static void performUnion(Set s1, Set s2) {
		Set s1Unions2 = new HashSet(s1);
		s1Unions2.addAll(s2);
		System.out.println("s1 union s2: " + s1Unions2);
	}

	public static void performIntersection(Set s1, Set s2) {
		Set s1Intersections2 = new HashSet(s1);
		s1Intersections2.retainAll(s2);
		System.out.println("s1 intersection s2: " + s1Intersections2);
	}

	public static void performDifference(Set s1, Set s2) {
		Set s1Differences2 = new HashSet(s1);
		s1Differences2.removeAll(s2);

		Set s2Differences1 = new HashSet(s2);
		s2Differences1.removeAll(s1);

		System.out.println("s1 difference s2: " + s1Differences2);
		System.out.println("s2 difference s1: " + s2Differences1);
	}

	public static void testForSubset(Set s1, Set s2) {
		System.out.println("s2 is subset s1: " + s1.containsAll(s2));
		System.out.println("s1 is subset s2: " + s2.containsAll(s1));
	}
}
