// SortedSetComparatorTest.java
package com.jdojo.chapter12;

import java.util.Comparator;
import java.util.SortedSet;
import java.util.TreeSet;

public class SortedSetComparatorTest {
	public static void main(String[] args) {
		Comparator idComparator = getIdComparator();
		Comparator nameComparator = getNameComparator();

		// Create a sorted set using id comparator
		SortedSet ss1 = new TreeSet(idComparator);
		ss1.add(new Person(1, "John"));
		ss1.add(new Person(2, "Adam"));
		ss1.add(new Person(3, "Eve"));
		ss1.add(new Person(4, "Donna"));
		ss1.add(new Person(4, "Donna")); // Duplicate Person!!!
		                                 // Will be ignored

		System.out.println("ss1: " + ss1);

		// Create a sorted set using name comparator
		SortedSet ss2 = new TreeSet(nameComparator);
		ss2.add(new Person(1, "John"));
		ss2.add(new Person(2, "Adam"));
		ss2.add(new Person(3, "Eve"));
		ss2.add(new Person(4, "Donna"));

		System.out.println("ss2: " + ss2);
	}

	public static Comparator getIdComparator() {
		// Create a Comparator object
		Comparator idComparator = new Comparator() {
			public int compare(Object o1, Object o2) {
				Person p1 = (Person) o1;
				Person p2 = (Person) o2;
				if (p1.getId() > p2.getId()) {
					return 1;
				} else if (p1.getId() < p2.getId()) {
					return -1;
				}

				return 0;
			}
		};

		return idComparator;
	}

	public static Comparator getNameComparator() {
		Comparator nameComparator = new Comparator() {
			public int compare(Object o1, Object o2) {
				Person p1 = (Person) o1;
				Person p2 = (Person) o2;
				String name1 = p1.getName();
				String name2 = p2.getName();

				// Use string comparison defined in the String class
				return name1.compareTo(name2);
			}
		};

		return nameComparator;
	}
}
