// SortedSetSubset.java
package com.jdojo.chapter12;

import java.util.SortedSet;
import java.util.TreeSet;

public class SortedSetSubset {
	public static void main(String[] args) {
		// Create a sorted set
		SortedSet ss1 = new TreeSet();
		ss1.add("John");
		ss1.add("Adam");
		ss1.add("Eve");
		ss1.add("Donna");

		System.out.println("Sorted Set: " + ss1);

		System.out.println("First: " + ss1.first());
		System.out.println("Last: " + ss1.last());

		SortedSet ssBeforeDonna = ss1.headSet("Donna");
		System.out.println("Head Set Before Donna: " + ssBeforeDonna);

		SortedSet ssBetwenDonnaAndJohn = ss1.subSet("Donna", "John");
		System.out.println(
				"Subset between Donna and John (exclusive): " + 
				ssBetwenDonnaAndJohn);

		// Note the trick “John” + “\0” to include “John” 
		// in the subset
		SortedSet ssBetwenDonnaAndJohn2 = 
							ss1.subSet("Donna", "John" + "\0");
		System.out.println(
				"Subset between Donna and John (Inclusive): " + 
				 ssBetwenDonnaAndJohn2);

		SortedSet ssDonnaAndAfter = ss1.tailSet("Donna");
		System.out.println("Subset from Donna onwards: " + 
		                    ssDonnaAndAfter);
	}
}
