// TransferQueueTest.java
package com.jdojo.chapter12;

import java.util.concurrent.LinkedTransferQueue;
import java.util.concurrent.TransferQueue;
import java.util.concurrent.atomic.AtomicInteger;

public class TQTest {	
	public static void main(String[] args) {
		final TransferQueue tQueue = new LinkedTransferQueue();
		final AtomicInteger sequence = new AtomicInteger();
	
		// Initialize transfer queue with five items
		for(int i = 0; i < 5; i++) {
			try {
				tQueue.put(sequence.incrementAndGet());
			} 
			catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		System.out.println("Initial queue: " + tQueue);
		
		// Create and start a producer and a consumer
		TQProducer p1 = new TQProducer("Producer-1", tQueue, sequence);	
		TQConsumer c1 = new TQConsumer("Consumer-1", tQueue);		
		p1.start();
		c1.start();
	}
}
