//CallbackTest.java
package com.jdojo.chapter3;

import java.util.ArrayList;

public class CallbackTest {
	// To hold all registered Callable objects
	private ArrayList callableList = new ArrayList();

	public static void main(String[] args) {
		CallbackTest cbt = new CallbackTest();

		// Create three Callable objects and registered them
		Callable c1 = cbt.generateCallable(1);
		cbt.register(c1);

		Callable c2 = cbt.generateCallable(2);
		cbt.register(c2);

		Callable c3 = cbt.generateCallable(3);
		cbt.register(c3);

		// Callback all the registered Callable objects
		cbt.callback();
	}

	private void callback(){
		int count = this.callableList.size();

		// Callback all the registered Callable objects
		for(int i = 0; i < count ; i++){
			Callable c = (Callable)this.callableList.get(i);
			c.call();
		}
	}

	public void register(Callable c){
		this.callableList.add(c);
	}

	// The no argument is final to be used in anonymous class 
	public Callable generateCallable(final int no){
		// Note that this object is created here, but it's call() 
		// method is used later. It is also capturing the method 
		// parameter no which will be used in printing a message later	
		Callable c = new Callable() {
			public void call() {
				System.out.println("Called #" + no);
			}
		};

		return c;
	}
} 
