// TitleListWithInnerClass.java
package com.jdojo.chapter3;

import java.util.ArrayList;
import java.util.Iterator;

public class TitleListWithInnerClass {
	private ArrayList titleList = new ArrayList();

	public void addTitle (String title) {
		titleList.add(title);
	}

	public void removeTitle(String title){
		titleList.remove(title);
	}

	public Iterator titleIterator() {
		// An anonymous class 
		Iterator iterator = 
				new Iterator () {
					int count = 0;
					public boolean hasNext() {
						return (count < titleList.size());
					}
			
					public Object next() {
						return titleList.get(count++);
					}
			
					public void remove() {
						throw new UnsupportedOperationException();
					}
				}; // Anonymous inner class ends here
		
				return iterator;
	}
}
