// EnumSetTest.java
package com.jdojo.chapter4;

import java.util.EnumSet;
import java.util.Iterator;

public class EnumSetTest {
	public static void main(String[] args) {
		// Print all enum constants of Day enum type
		System.out.println("All days using a for-each loop...");

		for(Day d: EnumSet.allOf(Day.class)) {
			System.out.print(d + " ");
		}
	
		System.out.println("\n\nOnly weekdays using a for-each loop.");	

		for(Day d: EnumSet.range(Day.MONDAY, Day.FRIDAY)) {
			System.out.print(d + " ");
		}
		
		System.out.println("\n\nOnly weekdays using an iterator.");	
 
		EnumSet<Day> weekDays = EnumSet.range(Day.MONDAY, Day.FRIDAY);
		Iterator<Day> iterator = weekDays.iterator();
		while(iterator.hasNext()) {
			Day d = iterator.next();
			System.out.print(d + " ");
		}	
		
		System.out.println("\n\nOnly weekends using a for-each loop.");

		for(Day d: EnumSet.complementOf(weekDays)) {
			System.out.print(d + " ");    
		}
	}
}
