// SuperSmartSeverity.java
package com.jdojo.chapter4;

public enum SuperSmartSeverity {
	LOW("Low Priority", 30) {
		public double getProjectedCost() {
			return 1000.0;
		}
	},
	MEDIUM("Medium Priority", 15) {
		public double getProjectedCost() {
			return 2000.0;
		}
	}, 
	HIGH("High Priority", 7) {
		public double getProjectedCost() {
			return 3000.0;
		}
	}, 
	URGENT("Urgent Priority", 1) {
		public double getProjectedCost() {
			return 5000.0;
		}
	};

	// Declare instance variables
	private String description;
	private int projectedTurnaroundDays;

	// Declare a private constructor
	private SuperSmartSeverity(String description,
	                           int projectedTurnaroundDays){
		this.description = description;
		this.projectedTurnaroundDays = projectedTurnaroundDays;
	}

	// Declare a public method to get the turn around days
	public int getProjectedTurnAroundDays() {
		return projectedTurnaroundDays;
	}
	
	// Override toString() method of Enum class to return description
	@Override
	public String toString() {
		return this.description;	
	}
	
	// Provide getProjectedCost() abstract method, so that all constants 
	// override and provide implementation for it in their body
	public abstract double getProjectedCost();
}
