// AccessPrivateField.java
package com.jdojo.chapter5;

import java.lang.reflect.Field;

public class AccessPrivateField {
	public static void main(String[] args) {
		String className = "com.jdojo.chapter5.Person";
		try {
			Class c = Class.forName(className);

			// Create an object of Person class
			Person p = (Person) c.newInstance();
			
			// Get the reference to name field
			Field nameField = c.getDeclaredField("name");
			
			// Make the private name field accessible
			nameField.setAccessible(true);
			
			// Get the current value of name field
			String nameValue = (String) nameField.get(p);			 
			System.out.println("Current Value of name: " + nameValue);
			
			// Set a new value for name			 
			nameField.set(p, "Sherry");
			
			// Read the new value of name
			nameValue = (String) nameField.get(p);			 
			System.out.println("New Value of name: " + nameValue);			
		}
		catch(Exception e) {
			System.out.println("Exception:" + e.getMessage());
		}
	}
}
