// ExpandingArray.java
package com.jdojo.chapter5;

import java.lang.reflect.Array;

public class ExpandingArray {
	public static void main(String[] args) {
		// Create an array of length 2
		int[] array = { 101, 102 } ;
		System.out.println("Old array length: " + array.length);
		System.out.println("Old array elements:");
		for (int a : array){
			System.out.println(a);
		}

		// Expand the array by 1
		array = (int[]) expandBy(array, 1);

		// Set the third element to 103
		array[2] = 103;	// This is newly added element
		System.out.println("\nNew array length: " + array.length);
		System.out.println("New array elements:");
		for (int a : array){
			System.out.println(a);      
		}
	}

	public static Object expandBy(Object oldArray, int increment) {
		Object newArray = null;

		// Get the length of old array using reflection       
		int oldLength = Array.getLength(oldArray);
		int newLength = oldLength + increment;

		// Get the class of old array
		Class c = oldArray.getClass();

		// Create new array of new length
		newArray = Array.newInstance(c.getComponentType(), newLength);

		// Copy the old array elements to new array
		System.arraycopy(oldArray, 0, newArray, 0, oldLength);

		return newArray;
	}
}
