// FieldAccessTest.java
package com.jdojo.chapter5;

import java.lang.reflect.Field;
    
public class FieldAccessTest {
	public static void main(String[] args) {
		String className = "com.jdojo.chapter5.PublicPerson";
		try {
			Class c = Class.forName(className);

			// Create an object of PublicPerson class
			PublicPerson p = (PublicPerson)c.newInstance();

			// Get the reference of name field
			Field name = c.getField("name");

			// Get the current value of name field
			String nameValue = (String) name.get(p);
			System.out.println("Current name is: " + nameValue);
			
			// Set the value of name to Ann
			name.set(p, "Ann");
			
			// Get the new value of name field
			nameValue = (String) name.get(p);
			System.out.println("New name is: " + nameValue);
		}
		catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
}
