// FieldReflection.java
package com.jdojo.chapter5;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

public class FieldReflection {
	public static void main(String[] args) {
		String className = "com.jdojo.chapter5.Person";

		try {
			Class c = Class.forName(className);

			// Get the declared fields
			String fieldsDesciption = getDeclaredFieldsList(c, ";\n");
			System.out.println("Declared Fields for - " + className);
			System.out.println(fieldsDesciption);
			
			// Get the accessible public fields
			fieldsDesciption = getFieldsList(c, ";\n");
			System.out.println("Fields for - " + className);
			System.out.println(fieldsDesciption);
		}
		catch (ClassNotFoundException e) {
			System.out.println("Exception:" + e.getMessage());
		}
	}

	public static String getFieldsDesciption(Field[] fields, 
									    String separator) {
		StringBuffer fieldsDesc = new StringBuffer();

		for (Field f : fields) {
			// Get the modifiers for the class
			int mod = f.getModifiers();
			String modifiers = Modifier.toString(mod);
			fieldsDesc.append(modifiers);
			
			// Get the simple name of the field type
			Class type = f.getType();
			String typeName = type.getSimpleName();
			fieldsDesc.append(" " + typeName);
			
			// Get the name of the field
			String fieldName = f.getName();
			fieldsDesc.append(" " + fieldName);			
			
			// Append the separator
			fieldsDesc.append(separator);				
		}

		return fieldsDesc.toString();
	}

	public static String getFieldsList(Class c, String separator) {
		Field[] fields = c.getFields();
		String fieldsList = getFieldsDesciption(fields, separator);
		return fieldsList;
	}

	public static String getDeclaredFieldsList(Class c, 
	                                           String separator) {
		Field[] fields = c.getDeclaredFields();
		String fieldsList = getFieldsDesciption(fields, separator);
		return fieldsList;
	}
}
