// InvokeMethodTest.java
package com.jdojo.chapter5;

import java.lang.reflect.Method;

public class InvokeMethodTest {
	public static void main(String[] args) {
		String className = "com.jdojo.chapter5.Person";
		try {
			Class c = Class.forName(className);

			// Create an object of Person class
			Person p = (Person) c.newInstance();
			System.out.println(p);
			 
			// Get the reference of setName() method
			Method setName = c.getMethod("setName", String.class);
			 
			// Invoke the setName() method on p passing a new value
			// for name as "Ann"
			setName.invoke(p, "Ann");
			System.out.println(p);
		}
		catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
}
