// GenericWrapperUtil.java
package com.jdojo.chapter6;

import java.util.Collection;

public class GenericWrapperUtil {
	public static void printDetails(GenericWrapper<?> gw) {
		// Can assign get() return value to Object
		Object value = gw.get();
		String className = null;

		if (value != null) {
			className = value.getClass().getName();
		}

		System.out.println("Class: " + className);
		System.out.println("Value: " + value);
	}

	public static double sum(GenericWrapper<? extends Number> n1,
	                         GenericWrapper<? extends Number> n2) {
		Number num1 = n1.get();
		Number num2 = n2.get();
		double sum = num1.doubleValue() + num2.doubleValue();
		return sum;
	}

	public static <T> void copy(GenericWrapper<T> source,
	                            GenericWrapper<? super T> dest) {
		T a = source.get();
		dest.set(a);
	}
}
