// BadCallableTask.java
package com.jdojo.chapter7;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;
import java.util.concurrent.ExecutionException;

public class BadCallableTask {    
	public static void main(String[] args) {  
		class BadTask implements Callable {
			public Object call() {
				throw new RuntimeException(
					"Throwing exception from task execution...");
			}
		}

		ExecutorService exec = Executors.newSingleThreadExecutor();

		BadTask t = new BadTask();
		Future submittedTask = exec.submit(t);
		
		try {
			// The get method should throw ExecutionException
			Object result = submittedTask.get();
		}
		catch(ExecutionException ee) {
			System.out.println("Execution exception has occurred: " + 
			                    ee.getMessage());
			System.out.println("Execution exception cause is: " + 
			                    ee.getCause().getMessage());
		}
		catch(InterruptedException ie) {
			ie.printStackTrace();
		}
		exec.shutdown();
	}
}
