// BalanceUpdateSynchronized.java
package com.jdojo.chapter7;

public class BalanceUpdateSynchronized {
	// Start with balance as 100
	private static int balance = 100;

	public static void main(String[] args) {
		// Start two threads to update the balance
		startBalanceUpdateThread();

		// Start one thread to monitor the balance
		startBalanceMonitorThread();
	}

	public static synchronized void updateBalance() {
		// Add 10 to balance and subtract 10 from balance
		balance = balance + 10;
		balance = balance - 10;
	}

	public static synchronized void monitorBalance() {
		int b = balance;
		if (b != 100) {
			System.out.println("Balance changed: " + b);
			System.exit(1); // Exit the program
		}
	}

	public static void startBalanceUpdateThread() {
		// Start a new thread that calls updateBalance() method
		Thread t = new Thread() {
					public void run() {
						while (true) {
							updateBalance();
						}
					}
				 };
		t.start();
	}

	public static void startBalanceMonitorThread() {
		// Start a thread that monitors the balance value
		Thread t = new Thread() {
					public void run() {
						while (true) {
							monitorBalance();
						}
					}
				 };
		t.start();
	}
}
