// BlockedInterrupted.java
package com.jdojo.chapter7;

public class BlockedInterrupted {
	public static void main(String[] args) {
		class SleepingThread extends Thread {
			public void run() {
				int counter = 1;
				while(true) {
					try {
						Thread.sleep(1000);
						System.out.println("Counter:" + counter++);
					}
					catch(InterruptedException e) {
						System.out.println("I got interrupted!");

						// Terminate the thread by returning
						return; 
					}
				}
			}
		} // Inner class SleepingThread ends here

		SleepingThread st = new SleepingThread();
		st.start();

		// main thread sleeps for 5 seconds
		try {
			Thread.sleep(5000);
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}
	
		// Interrupt the sleeping thread 
		st.interrupt();    
	}
}
