// SimpleExplicitLock.java
package com.jdojo.chapter7;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class SimpleExplicitLock {
	// Instantiate the lock object
	private Lock myLock = new ReentrantLock();

	public void updateResource() {
		// Acquire the lock
		myLock.lock();

		try {
			// Logic that deals with updating/reading the 
			// shared resources go here...
		}
		finally {
			// Release the lock
			myLock.unlock();
		}
	}
}
