// SimpleInterruptAnotherThread.java
package com.jdojo.chapter7;

public class SimpleInterruptAnotherThread {
	public static void main(String[] args) {
		// Local inner class
		class CounterThread extends Thread {
			public void run() {
				int counter = 0;

				while(!Thread.interrupted()) {
					counter++;
				}
				System.out.println("Counter:" + counter);
			}
		}

		CounterThread t = new CounterThread();
		t.start();

		// Let main thread sleep for 1 second
		try {
			Thread.currentThread().sleep(1000);
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}

		// Now interrupt the counter thread
		t.interrupt();
	}
}
