//BufferedFileReading.java
package com.jdojo.chapter8;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class BufferedFileReading {
	public static void main(String[] args) {
		String dataSourceFile = "luci1.txt";
		BufferedInputStream bis = null;
		try {
			// Create a buffered file input stream
			bis = new BufferedInputStream( 
					new FileInputStream(dataSourceFile)
				 );

			// Read one byte at a time and display it
			byte byteData;
			while ((byteData = (byte)bis.read()) != -1){
				System.out.print((char)byteData);
			}
		}
		catch (FileNotFoundException e1) {
			String currentDirectory = System.getProperty("user.dir");
			System.out.println("Could not find the file : " + 					                   dataSourceFile + " in " + 
			                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the input stream
			if (bis != null) {
				try {
					bis.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
} 
