// FileWritingWithPrintStream.java
package com.jdojo.chapter8;

import java.io.PrintStream;
import java.io.FileNotFoundException;

public class FileWritingWithPrintStream {
	public static void main(String[] args) {
		String dataSinkFile = "luci3.txt";

		// Get the current directory for later use
		String currentDirectory = System.getProperty("user.dir");

		PrintStream ps = null;

		try {
			// Create print stream object using dataSinkFile
			ps = new PrintStream(dataSinkFile);

			// Write data to file. println() appends a new line 
			ps.println("Upon the moon I fix’d my eye,");
			ps.println("All over the wide lea;");
			ps.println("With quickening pace my horse drew nigh");
			ps.print("Those paths so dear to me.");

			ps.flush();	// flush the print stream

			System.out.println("Output has been written to: " + 
			                   dataSinkFile+ " in " + 
			                   currentDirectory + " directory ");
			// print stream is closed in the finally block
		}
		catch (FileNotFoundException e1) {
			System.out.println("Could not create the file : " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
		}
		finally {
			if (ps != null) {		  
				ps.close(); // Close the print stream
			}
		}
	}
}
