// FileWritingWithWriter.java
package com.jdojo.chapter8;

import java.io.FileNotFoundException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

public class FileWritingWithWriter {
	public static void main(String[] args) {
		String dataSinkFile = "luci4.txt";

		// Get the current directory for later use
		String currentDirectory = System.getProperty("user.dir");

		BufferedWriter bw = null;
		try {
			// Create BufferedWriter a FileWriter using dataSinkFile
			bw = new BufferedWriter(new FileWriter(dataSinkFile));

			// Write the text to the writer
			bw.append("And now we reach’d the orchard-plot;");
			bw.newLine();
			bw.append("And, as we climb’d the hill,");
			bw.newLine();
			bw.append("The sinking moon to Lucy’s cot");
			bw.newLine();
			bw.append("Came near and nearer still.");

			// flush the print stream
			bw.flush();

			System.out.println("Output has been written to: " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
			// writer stream is closed in the finally block
		}
		catch (FileNotFoundException e1) {
			System.out.println("Could not create the file : " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the output stream
			if (bw != null) {
				try {
					bw.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
