// FilteredFileList.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileFilter;

public class FilteredFileList {
	public static void main(String[] args) {
		// Change the dirPath value to list files from your directory
		String dirPath = "C:\\";
		File dir = new File(dirPath);
		
		// Create a file filter to exclude any .SYS file
		FileFilter filter = new FileFilter() {
			public boolean accept(File pathName) {
				if (pathName.isFile()) {
					String fileName = 
						pathName.getName().toLowerCase();
					if (fileName.endsWith(".sys")) {
						return false;
					}
				}
				return true;
			}
		};

		// Pass the filter object to listFiles() method
		// to exclude .sys files
		File[] list = dir.listFiles(filter);

		for (File f : list) {
			if (f.isFile()) {
				System.out.println(f.getPath() + " (File)");
			}
			else if (f.isDirectory()) {
				System.out.println(f.getPath() + " (Directory)");
			}
		}
	}
}
