// LowerCaseReader.java
package com.jdojo.chapter8;

import java.io.Reader;
import java.io.FilterReader;
import java.io.IOException;

public class LowerCaseReader extends FilterReader{
	public LowerCaseReader(Reader in) {
		super(in);
	}

	public int read() throws IOException {
		int c = super.read();
		if (c != -1) {
			// Convert the character to the lowercase
			c = Character.toLowerCase((char)c);
		}
		return c;
	}

	public int read(char[] cbuf, int off, int len) throws IOException {
		int count = super.read(cbuf, off, len);
		if (count != -1) {
			// Convert all read characters to the lowercase
			int limit = off + count;
			for (int i = off; i < limit; i++) {
				cbuf[i] = Character.toLowerCase(cbuf[i]);
			}
		}
		return count;
	}
}
