// PersonDeserializationTest.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

public class PersonDeserializationTest {
	public static void main(String[] args) {
		// Make sure person.ser file exists in the current directory
		File fileObject = new File("person.ser");
		ObjectInputStream ois = null;
		
		try {
			// Create an object of ObjectOutputStream            
			ois = new ObjectInputStream (
					new FileInputStream(fileObject)
				 );

			// Read (or deserialize) the three objects 
			Person john = (Person)ois.readObject();
			Person wally = (Person)ois.readObject();
			Person katrina = (Person)ois.readObject();
		
			// Let us display the objects we have read on console
			System.out.println("Three objects are read from " + 
			                   fileObject.getAbsolutePath());
			System.out.println(john);
			System.out.println(wally);
			System.out.println(katrina);			
			// object input stream is closed in finally block        
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		catch (ClassNotFoundException e2) {
			e2.printStackTrace();
		}		
		finally {
			if (ois != null) {
				try {
					ois.close();
				}
				catch(IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
