// PersonExtDeserializationTest.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

public class PersonExtDeserializationTest {
	public static void main(String[] args) {
		// personext.ser file must exist in the current directory	
		File fileObject = new File("personext.ser");
		ObjectInputStream ois = null;
		
		try {
			// Create an object of ObjectOutputStream		    
			ois = new ObjectInputStream (
					new FileInputStream(fileObject)
				 );
	
			// Read (or deserialize) the three objects 
			PersonExt john = (PersonExt)ois.readObject();
			PersonExt wally = (PersonExt)ois.readObject();
			PersonExt katrina = (PersonExt)ois.readObject();
			
			// Display the deserialized objects
			System.out.println("Three objects are read from " + 
			                   fileObject.getAbsolutePath());

			System.out.println(john);
			System.out.println(wally);
			System.out.println(katrina);			
			// the object input stream is closed in the finally block
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		catch (ClassNotFoundException e2) {
			e2.printStackTrace();
		}
		finally {
			if (ois != null) {
				try {
					ois.close();
				}
				catch(IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
