// PersonExtSerializationTest.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

public class PersonExtSerializationTest {
	public static void main(String[] args) {        
		// Create three Person objects
		PersonExt john = new PersonExt("John", "Male", 6.7);
		PersonExt wally = new PersonExt("Wally", "Male", 5.7);
		PersonExt katrina = new PersonExt("Katrina", "Female", 5.4);
				
		File fileObject = new File("personext.ser");
		ObjectOutputStream oos = null;
		
		try {
			// Create an ObjectOutputStream object
			oos = new ObjectOutputStream (
					new FileOutputStream(fileObject)
				 );
	
			// Write (or serialize) the three objects 
			oos.writeObject(john);
			oos.writeObject(wally);
			oos.writeObject(katrina);

			// Display the serialized objects 
			System.out.println("Three objects are written to: " +
							fileObject.getAbsolutePath());

			System.out.println(john);
			System.out.println(wally);
			System.out.println(katrina);
			// the object output stream is closed in the finally block        
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		finally {
			if (oos != null) {
				try {
					oos.close();
				}
				catch(IOException e2) {
					e2.printStackTrace();
				}
			}
		}
	}
}
