// PersonNameSerialization.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class PersonNameSerialization {
	public static void serialize(String fileName){
		File fileObject = new File(fileName);
		ObjectOutputStream oos = null; 
		try {
			// Create an object of the ObjectOutputStream class
			oos = new ObjectOutputStream (
					new FileOutputStream(fileObject)
				 );

			// Write a PersonName object to the output stream
			PersonName name = new PersonName("John Jacobs");
			oos.writeObject(name);  
		
			// Display the serialized object
			System.out.println("One object is written to: " + 
			fileObject.getAbsolutePath());
			System.out.println(name);		
			// the object output stream is closed in the finally block
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		finally {
			if (oos != null) {
				try {
					oos.close();
				}
				catch(IOException e2) {
					e2.printStackTrace();
				}
			}
		}
	}

	public static void deserialize(String fileName) {
		File fileObject = new File(fileName);
		ObjectInputStream ois = null;
		
		try {
			// Create an object of the ObjectInputStream class
			ois = new ObjectInputStream (
					new FileInputStream(fileObject)
				 );

			// Read one PersonName object 
			PersonName name = (PersonName)ois.readObject();
		 
			// Display the deserialized object
			System.out.println("One object is read from: " + 
			                   fileObject.getAbsolutePath());
			System.out.println(name); 
			// the object input stream is closed in the finally block  
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		catch (ClassNotFoundException e2) {
			e2.printStackTrace();
		}		
		finally {
			if (ois != null) {
				try {
					ois.close();
				}
				catch(IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
