// PersonSerializationTest.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

public class PersonSerializationTest {
	public static void main(String[] args) {
		// Create three Person objects
		Person john = new Person("John", "Male", 6.7);
		Person wally = new Person("Wally", "Male", 5.7);
		Person katrina = new Person("Katrina", "Female", 5.4);

		File fileObject = new File("person.ser");
		ObjectOutputStream oos = null;

		try {
			// Create an object of ObjectOutputStream            
			oos = new ObjectOutputStream (
					new FileOutputStream(fileObject)
				 );

			// Write (or serialize) the three objects to the
			// object output stream
			oos.writeObject(john);
			oos.writeObject(wally);
			oos.writeObject(katrina);
			
			// Display the serialized objects on the standard output
			System.out.println("Three objects are written to: " + 
			                   fileObject.getAbsolutePath());

			System.out.println(john);
			System.out.println(wally);
			System.out.println(katrina);			
			// the object output stream is closed in finally block			
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		finally {
			if (oos != null) {
				try {
					oos.close();
				}
				catch(IOException e2) {
					e2.printStackTrace();
				}
			}
		}
	}
}
