// PersonTransDeserializationTest.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

public class PersonTransDeserializationTest {
	public static void main(String[] args) {
		// persontrans.ser file must exist in the current directory        
		File fileObject = new File("persontrans.ser");
		ObjectInputStream ois = null;
		
		try {
			// Create an object of ObjectOutputStream		    
			ois = new ObjectInputStream (
					new FileInputStream(fileObject)
				  );
					 
			// Read (or deserialize) the three objects 
			PersonTrans john = (PersonTrans)ois.readObject();
			PersonTrans wally = (PersonTrans)ois.readObject();
			PersonTrans katrina = (PersonTrans)ois.readObject();
			
			// Display the objects 
			System.out.println("Three objects are read from " + 
			                   fileObject.getAbsolutePath());
			System.out.println(john);
			System.out.println(wally);
			System.out.println(katrina);			
			// the object input stream is closed in the finally block
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		catch (ClassNotFoundException e2) {
			e2.printStackTrace();
		}		
		finally {
			if (ois != null) {
				try {
					ois.close();
				}
				catch(IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
