// PersonTransSerializationTest.java
package com.jdojo.chapter8;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

public class PersonTransSerializationTest {
	public static void main(String[] args) { 
		// Create three PersonTrans objects
		PersonTrans john = new PersonTrans("John", "Male", 6.7);
		PersonTrans wally = new PersonTrans("Wally", "Male", 5.7);
		PersonTrans katrina = new PersonTrans("Katrina","Female", 5.4);
				
		File fileObject = new File("persontrans.ser");
		ObjectOutputStream oos = null;
		
		try {
			// Create an object of ObjectOutputStream            
			oos = new ObjectOutputStream (
					new FileOutputStream(fileObject)
				 );

			// Write (or serialize) the three objects 
			oos.writeObject(john);
			oos.writeObject(wally);
			oos.writeObject(katrina);
			
			// Display the serialized objects 
 			System.out.println("Three objects are written to: " + 
			                   fileObject.getAbsolutePath());

			System.out.println(john);
			System.out.println(wally);
			System.out.println(katrina);			
			// object output stream is closed in the finally block
		}
		catch(IOException e1) {
			e1.printStackTrace();
		}
		finally {
			if (oos != null) {
				try {
					oos.close();
				}
				catch(IOException e2) {
					e2.printStackTrace();
				}
			}
		}
	}
}
