// PushbackFileReading.java
package com.jdojo.chapter8;

import java.io.PushbackInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class PushbackFileReading {
	public static void main(String[] args) {
		String dataSourceFile = "luci1.txt";
		PushbackInputStream pis = null;
		try {
			// Create a pushback file input stream
			pis = new PushbackInputStream(
					new FileInputStream(dataSourceFile)
				 );

			// Read one byte at a time and display it
			byte byteData;
			while ((byteData = (byte)pis.read()) != -1){
				System.out.print((char)byteData);
		
				// Unread the last byte that we have just read
				pis.unread(byteData);
	
				// Reread the byte we unread (pushed back)
				byteData = (byte)pis.read();
				System.out.print((char)byteData);
			}
		}
		catch (FileNotFoundException e1) {
			String currentDirectory = System.getProperty("user.dir");
			System.out.println("Could not find the file : " + 
			                   dataSourceFile + " in " + 
			                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the input stream
			if (pis != null) {
				try {
					pis.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
