// ReadingPrimitives.java
package com.jdojo.chapter8;

import java.io.IOException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.DataInputStream;

public class ReadingPrimitives {
	public static void main(String[] args) {
		String dataSourceFile = "primitives.dat";
		String currentDirectory = System.getProperty("user.dir");

		DataInputStream dis = null;
		try {
			// Create a data input stream for a file
			dis = new DataInputStream(
					new FileInputStream(dataSourceFile)
				 );

			// Read the data in the same order they were written
			int intValue = dis.readInt();
			double doubleValue = dis.readDouble();
			boolean booleanValue = dis.readBoolean();
			String msg = dis.readUTF();

			System.out.println(intValue);
			System.out.println(doubleValue);
			System.out.println(booleanValue);
			System.out.println(msg);
			// data input stream is closed in finally block
		}
		catch (FileNotFoundException e1) {
			System.out.println("Could not find the file: " + 
			                   dataSourceFile + " in " + 
			                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the output stream
			if (dis != null) {
				try {
					dis.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
