// SimpleFileReading.java
package com.jdojo.chapter8;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class SimpleFileReading {
	public static void main(String[] args) {
		String dataSourceFile = "luci1.txt";

		FileInputStream fin = null;
		try {
			// Create a file input stream
			fin = new FileInputStream(dataSourceFile);

			// Read from the file - one byte at a time and display
			// each byte read as a character
			byte byteData;
			while ((byteData = (byte)fin.read()) != -1){
				System.out.print((char)byteData);        
			}
		}
		catch (FileNotFoundException e1) {
			String currentDirectory = System.getProperty("user.dir");
		System.out.println("Could not find the file : " + 
		                   dataSourceFile + " in " +
		                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the input stream
			if (fin != null) {
				try {
					fin.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
