// SimpleFileReadingJava7.java
package com.jdojo.chapter8;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class SimpleFileReadingJava7 {
	public static void main(String[] args) {
		String dataSourceFile = "luci1.txt";

		// Specify the file input stream as a resource, which will be
		// closed automatically for us
		try (FileInputStream fin = 
							new FileInputStream(dataSourceFile)) {
			// Read from the file - one byte at a time and display
			// each byte read as a character
			byte byteData;
			while ((byteData = (byte)fin.read()) != -1){
				System.out.print((char)byteData);
			}
		}
		catch (FileNotFoundException e1) {
			String currentDirectory = System.getProperty("user.dir");
			System.out.println("Could not find the file : " +
							 dataSourceFile + " in " +
							 currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}		
	}
}
