// SimpleFileWriting.java
package com.jdojo.chapter8;

import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

public class SimpleFileWriting {
	public static void main(String[] args) {
		String dataSinkFile = "luci2.txt";
		
		// Get the current directory for later use
		String currentDirectory = System.getProperty("user.dir");
		
		// Get the line separator for the current platform
		String lineSeparator = System.getProperty("line.separator");

		String line1 = "When she I loved look'd every day";
		String line2 = "Fresh as a rose in June," ;
		String line3 = "I to her cottage bent my way,";
		String line4 = "Beneath an evening moon.";

		FileOutputStream fos = null;
		try {
			// Create a file output stream
			fos = new FileOutputStream(dataSinkFile);

			// Write all four lines to the output stream in bytes form
			fos.write(line1.getBytes());
			fos.write(lineSeparator.getBytes());

			fos.write(line2.getBytes());
			fos.write(lineSeparator.getBytes());

			fos.write(line3.getBytes());
			fos.write(lineSeparator.getBytes());

			fos.write(line4.getBytes());

			// Flush the written bytes to the file
			fos.flush();

			// Display the output file name and its path
			System.out.println("Output has been written to: " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
			// Output stream is closed in the finally block
		}
		catch (FileNotFoundException e1) {     
			System.out.println("Could not create the file : " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the output stream
			if (fos != null) {
				try {
					fos.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
