// WritingPrimitives.java
package com.jdojo.chapter8;

import java.io.IOException;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.DataOutputStream;

public class WritingPrimitives {
	public static void main(String[] args) {
		String dataSinkFile = "primitives.dat";
		String currentDirectory = System.getProperty("user.dir");

		DataOutputStream dos = null;
		try {
			// Create a data output stream for a file
			dos = new DataOutputStream(
					new FileOutputStream(dataSinkFile)
				 );
  
			// Write some primitive values and a string 
			dos.writeInt(765);
			dos.writeDouble(6789.50);
			dos.writeBoolean(true);
			dos.writeUTF("Java Input/Output is cool!");
		
			// Flush the written bytes to the file
			dos.flush();

			System.out.println("Output has been written to: " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
			// data output stream is closed in finally block
		}
		catch (FileNotFoundException e1) {
			System.out.println("Could not create the file : " + 
			                   dataSinkFile + " in " + 
			                   currentDirectory + " directory ");
		}
		catch (IOException e2) {
			e2.printStackTrace();
		}
		finally {
			// Let us close the output stream
			if (dos != null) {
				try {
					dos.close();
				}
				catch (IOException e3) {
					e3.printStackTrace();
				}
			}
		}
	}
}
